Subject: bug#31953: [VanL] Re: bug#31953: feature request - `highlight-rx` interactively

From: Drew Adams <[email-masked]>
Date: Tue, 15 Oct 2019 14:34:46 +0000 (UTC)

> I think it would be rather odd to have just one regexp-reading command
> that uses the rx syntax interactively.  If this is something we want
> (and I don't really envision people willingly typing in rx forms
> interactively), then it should be fixed in `read-regexp'.  It could,
> for instance, have a keystroke that changes the input mode.
> 
> But do we think that people want to type in rx forms?

(Apologies for jumping in here, ignoring the thread.)

FWIW -

Many applications, including some good ones, provide
dialog boxes (modal or not) for things like search &
replace that let you check a number of settings that
configure the kind of search (and replace).

Emacs generally favors progressive interaction: if
you need to specify multiple things then you are
prompted multiple times, or you use a prefix arg
together with perhaps responding to a single prompt.

But there's no reason that Emacs could not or should
not also offer such dialog boxes - including for
things like Isearch.  (If I had more free time
perhaps I'd wrestle something up with widgets.)

The other thing is that originally Isearch was simple,
in terms of the possibilities it offered.  That's
changed over time (char folding and lots of other
things).  The ability to configure multiple search
settings at once, with a straightforward dialog box,
and then reuse the same settings or modify them, is
a feature waiting to happen.

And I think configuring rx searches would be a great
candidate for this kind of thing.  I don't use RX,
mainly because I'm used to regexps and it think it
would be slower to use RX.  But not necessarily so,
if it's just a question of checking a few boxes.

It should be quick to configure a given search.
And it's super clear because the dialog box can lay
it all out and even provide helpful tooltips for
fields/actions.  And once configured just repeat,
with or without changing some setting.

I say go for it - even without a dialog box.

Do people really "want to type in rx forms?"  Maybe
not.  But later on we could give them a dialog box
that takes the place of typing in rx syntax ("forms").